c Programme tested on  24/09/98
c    Didier Poilblanc

c---------------------
      program diagonal
c---------------------
       
      implicit integer (h-z)        
*     construction de l espace de hilbert
c      parameter (n=16,nconf=12870,ilim=2**n-1)
c      parameter (n=8,nconf=70,ilim=2**n-1)
      parameter (n=12,nconf=924,ilim=2**n-1)
      parameter (nup=n/2,ndown=n-nup,pmax=100)
      real*8 vec(nconf), vecf(nconf),veci(nconf)
      real*8 norm,a,b
      integer conf (nconf)
      integer h(nconf,n) 

      common /conf/ conf
      common /h/ h
      p=0
      do i=1,ilim
         call popcnt(n,i,k)
         if (k.eq.nup) then 
            p=p+1 
            conf(p)=i
         endif      
      enddo

      if (p.ne.nconf) stop 10

c      write(*,*) (conf(i),i=1,nconf)

*     construction de la matrice
      do k=1,nconf
         do l=1,n
            h(k,l)=0
         enddo
      enddo
      do i=1,nconf
         p=1
         do j=1,n-1
            call im( conf(i),ima,j,n)
            if (ima.ne.0) then
               call nbre(ima,indice)
               h(i,p)=indice
c               write(*,*) h(i,p)
c               read(*,*)
               p=p+1
            endif
         enddo
         call imp( conf(i),ima,n)
            if (ima.ne.0) then
               call nbre(ima,indice)
               h(i,p)=indice
               p=p+1
            endif 
      enddo
c test 
c      do k=1,nconf
c            write(*,*) (h(k,l), l=1,n)
c      enddo

      a=1/sqrt(2.)
      b=1/sqrt(3.)

      do i=1,nconf
         call random(a,b)
         veci(i)=-0.5+a
c         vec(i)=-0.5
      enddo

c      write(*,*)'coordonnees vecteur'
c      read(*,*)(vec(k),k=1,nconf)
      do p=1,pmax

         if (p.eq.1) then
            do l=1,nconf
               vec(l)=veci(l)
            enddo
c Normalisation
            norm=0.
            do i=1,nconf
               norm=norm+vec(i)**2
            enddo
            do i=1,nconf
               vec(i)=vec(i)/sqrt(norm)
            enddo
         else
            do l=1,nconf
               vec(l)=vecf(l)
            enddo
         endif

      call produit(vec,vecf,norm)
c      write(*,*) (vecf(k), k=1,nconf)

      print *, 'ener= ', norm/n
      enddo

      end

**********************************************************************      
      subroutine popcnt (n,i,k)
      k=0
      do j=0,n-1
         if (iand(ishft(i,-j),1).eq.1) k=k+1 
      enddo
      end
********************************************************************

      subroutine im(confi,imag,ii,n)      

      implicit integer (a-z)

      fullmask=2**n-1
      mask0=ishft(3,ii-1)
      mask1=ishft(2,ii-1)
      mask2=ishft(1,ii-1)
      mask0p=fullmask-mask0
      confip=iand(confi,mask0p)
      confi1=ior(confip,mask1)
      confi2=ior(confip,mask2)
      imag=0
      if (confi1.eq.confi) then
            imag=confi2
      endif
      if (confi2.eq.confi) then
         imag=confi1
      endif
c      write(*,*) confi,imag,ii
c      read(*,*)
      end
********************************************************************
      subroutine imp(confi,imag,n)      

      implicit integer (a-z)

      fullmask=2**n-1
      mask0=ior(1,ishft(1,n-1))
      mask1=ishft(1,n-1)
      mask2=1
      mask0p=fullmask-mask0
      confip=iand(confi,mask0p)
      confi1=ior(confip,mask1)
      confi2=ior(confip,mask2)
      imag=0
      if (confi1.eq.confi) then
            imag=confi2
      endif
      if (confi2.eq.confi) then
            imag=confi1
      endif
c      write(*,*) confi,imag
c      read(*,*)
      end

c*******************************************************************      
      subroutine nbre(imag,kout)
c*******************************************************************      

c      parameter (nconf=12870)
c      parameter (nconf=70)
      parameter (nconf=924)
      integer confs (nconf)

      common /conf/ confs

      do k=1,nconf
         if (imag.eq.confs(k)) then
            kout=k
            goto 20
         endif
      enddo
 20   continue
      end

c********************************************************************
      subroutine produit(vect,vectim,norm)
c********************************************************************

c      parameter (nconf=12870,n=16)
c      parameter (nconf=70,n=8)
      parameter (nconf=924,n=12)
      
      integer hp(nconf,n)
      real*8 vect(nconf), norm
      real*8 vectim(nconf)
      
      common /h/ hp
      do i=1,nconf
         vectim(i)=0
         do j=1,n
            if (hp(i,j).ne.0) then
               vectim(i)=vectim(i)+0.5*vect(hp(i,j))
            endif
         enddo
      enddo

c Normalisation
      norm=0.
      do i=1,nconf
         norm=norm+vectim(i)**2
      enddo
      norm=sqrt(norm)
      do i=1,nconf
         vectim(i)=vectim(i)/norm
      enddo

      end
      

      subroutine random(a,b)
c     genere 2 nb au hasard entre 0 et 1 

c      real*8 a1,b1,ia,ib,a,b
      real*8 a1,b1,a,b

        a1=a*16185.35432d0+b*b*31415.926354d0+0.35432d0
        b1=b*27182.814423d0+a*a*17321.4532d0+0.30367093d0
        ia=a1
        ib=b1
        a=a1-ia
        b=b1-ib

      end

      












